package model;

import java.io.DataInputStream;

public class LoadBinaryV1 implements Operation {
	private DataInputStream s;
	public LoadBinaryV1(DataInputStream s) {
		this.s = s;
	}
	public void doItOn(ToDoList l) throws Exception {
		l.name(s.readUTF());
		Date d = new Date();
		doItOn(d);
		l.dueDate(d);
		int n = s.readInt();
		for(int i = 0; i < n; i++) {
			ToDo t;
			switch(s.readChar()) {
				case ToDoList.CODE :
					t = new ToDoList();
					break;
				case SimpleToDo.CODE :
					t = new SimpleToDo();
					break;
				default :
					throw new Exception("Classe inconnue !");
			}
			//this.doItOn(t);
			t.performs(this);
			l.add(t);
		}
	}
	public void doItOn(ToDoList l, int margin) throws Exception {
		doItOn(l);
	}
	public void doItOn(SimpleToDo t) throws Exception {
		t.name(s.readUTF());
		t.setDone(s.readBoolean());
		Date d = new Date();
		doItOn(d);
		t.dueDate(d);
	}
	public void doItOn(SimpleToDo t, int margin) throws Exception {
		doItOn(t);
	}
	public void doItOn(Date d) throws Exception {
		d.year(s.readInt());
		d.month(s.readByte());
		d.day(s.readByte());
	}
	public void doItOn(Date d, int margin) throws Exception {
		doItOn(d);
	}
}
