package model;

import java.io.DataOutputStream;

public class SaveBinary implements Operation {
	private static Date zero = new Date();
	private DataOutputStream s;
	public SaveBinary(DataOutputStream s) {
		this.s = s;
	}
	public void doItOn(ToDoList l, int margin) throws Exception {
		s.writeChar(ToDoList.CODE);
		s.writeUTF(l.name());
		Date dueTo = l.dueDate(); doItOn((dueTo == null) ? zero : dueTo);
		s.writeInt(l.size());
		for(ToDo t : l) {
		//	this.doItOn(t);
			t.performs(this, 0);
		}
	}
	public void doItOn(ToDoList l) throws Exception {
		doItOn(l, 0);
	}
	public void doItOn(SimpleToDo t, int margin) throws Exception {
		s.writeChar(SimpleToDo.CODE);
		s.writeUTF(t.name());
		s.writeBoolean(t.isDone());
		Date dueTo = t.dueDate(); doItOn((dueTo == null) ? zero : dueTo);
	}
	public void doItOn(SimpleToDo t) throws Exception {
		doItOn(t, 0);
	}
	public void doItOn(Date d, int margin) throws Exception {
		s.writeInt(d.year());
		s.writeByte((byte)(d.month()));
		s.writeByte((byte)(d.day()));
	}
	public void doItOn(Date d) throws Exception {
		doItOn(d, 0);
	}
}
