package model;

import java.io.PrintWriter;

public class SaveText implements Operation {
	private PrintWriter w;
	public SaveText(PrintWriter w) {
		this.w = w;
	}
	private void indent(int margin) {
		for(int i = 0; i < margin; i++)
			w.print('\t');
	}
	public void doItOn(ToDoList l, int margin) throws Exception {
		indent(margin);
		w.print(l.name());
		w.print('\t');
		w.print((l.isDone()) ? "fait" : "à faire");
		w.print('\t');
		if (l.dueDate() != null) {
			w.print("\téchéance : ");
			doItOn(l.dueDate());
		}
		w.println();
		for(ToDo t : l) {
//			this.doItOn(t, margin + 1);
			t.performs(this, margin + 1);
		}
	}
	public void doItOn(ToDoList l) throws Exception {
		doItOn(l, 0);
	}
	public void doItOn(SimpleToDo t, int margin) throws Exception {
		indent(margin);
		w.print(t.name());
		w.print('\t');
		w.print((t.isDone()) ? "fait" : "à faire");
		if (t.dueDate() != null) {
			w.print("\téchéance : ");
			doItOn(t.dueDate());
		}
		w.println();
	}
	public void doItOn(SimpleToDo t) throws Exception {
		doItOn(t, 0);
	}
	public void doItOn(Date d, int margin) throws Exception {
		w.print(d);
	}
	public void doItOn(Date d) throws Exception {
		doItOn(d, 0);
	}
}
