package view;

import java.awt.event.KeyEvent;
import java.awt.event.ActionEvent;
import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.KeyStroke;

import controler.Controler;
import static java.awt.event.InputEvent.CTRL_DOWN_MASK;

@SuppressWarnings("serial")
public class MenuBar extends JMenuBar {
    private JMenuItem saveItem;
    private JMenuItem modifyItem;
    private JMenuItem deleteItem;
    private Controler controler;
    public MenuBar(Controler c, RemoveCommand remove, ChangeCommand change) {
    	super();
        controler = c;
        JMenu menu;
        JMenuItem item;

        menu = new JMenu("Pense-bête");
        add(menu);
        item = new JMenuItem("A propos...");
        item.addActionListener((ActionEvent e) -> controler.about());
        menu.add(item);
        menu.addSeparator();
        item = new JMenuItem("Quitter");
        item.setAccelerator(KeyStroke.getKeyStroke('Q', CTRL_DOWN_MASK));
        item.addActionListener((ActionEvent e) -> controler.quit());
        menu.add(item);
        
        menu = new JMenu("Choses à faire");
        add(menu);
        item = new JMenuItem("Ouvrir...");
        item.addActionListener((ActionEvent e) -> controler.loadToDo());
        menu.add(item);
        item = new JMenuItem("Enregistrer");
        item.setEnabled(false);
        saveItem = item;
        item.addActionListener((ActionEvent e) -> controler.saveToDo());
        menu.add(item);
        item = new JMenuItem("Enregistrer sous...");
        item.addActionListener((ActionEvent e) -> controler.saveToDoAs());
        menu.add(item);
        
        menu = new JMenu("Edition");
        add(menu);
        item = new JMenuItem("Nouvelle chose à faire");
        item.addActionListener((ActionEvent e) -> controler.newToDo());
        menu.add(item);
        menu.addSeparator();
        item = new JMenuItem("Modifier");
        //item.setAccelerator(KeyStroke.getKeyStroke("ctrl M"));
        item.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_ENTER, CTRL_DOWN_MASK));
        modifyItem = item;
        item.setEnabled(false);
        item.addActionListener(change);
        menu.add(item);
        item = new JMenuItem("Supprimer");
        //item.setAccelerator(KeyStroke.getKeyStroke("ctrl DELETE"));
        item.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_DELETE, CTRL_DOWN_MASK));
        deleteItem = item;
        item.setEnabled(false);
        item.addActionListener(remove);
        menu.add(item);
    }
    public void allowSaveItem(boolean b) {
    	saveItem.setEnabled(b);
    }
    public void allowModifyDeleteItems(boolean b) {
    	modifyItem.setEnabled(b);
    	deleteItem.setEnabled(b);
    }
}
